namespace Flibs {
    public class ExecuteData {
        private int _stateCount;
        private int _generationSize;
        private ICrossover _crossover;
        private IMutation _mutation;
        private int _checkCount;
        private int _generationCount;
        private ISignalSource _signalSource;
        private IGenerationCreator _generationCreator;
        private int _passCount;
        private readonly bool _isRestoreFlibs;

        public ExecuteData(int stateCount, int generationSize, ICrossover crossover, IMutation mutation,
                           int checkCount, int generationCount, ISignalSource signalSource, IGenerationCreator generationCreator,
                           int passCount, bool isRestoreFlibs) {
            _stateCount = stateCount;
            _generationSize = generationSize;
            _crossover = crossover;
            _mutation = mutation;
            _checkCount = checkCount;
            _generationCount = generationCount;
            _signalSource = signalSource;
            _generationCreator = generationCreator;
            _passCount = passCount;
            _isRestoreFlibs = isRestoreFlibs;
        }

        public int StateCount {
            get { return _stateCount; }
        }

        public int GenerationSize {
            get { return _generationSize; }
        }

        public ICrossover Crossover {
            get { return _crossover; }
        }

        public IMutation Mutation {
            get { return _mutation; }
        }

        public int CheckCount {
            get { return _checkCount; }
        }

        public int GenerationCount {
            get { return _generationCount; }
        }

        public ISignalSource SignalSource {
            get { return _signalSource; }
        }

        public IGenerationCreator GenerationCreator {
            get { return _generationCreator; }
        }

        public int PassCount {
            get { return _passCount; }
        }

        public bool IsRestoreFlibs {
            get { return _isRestoreFlibs; }
        }
    }
}