namespace Flibs {
    public class Flib {
        private State[] _states;
        private int _curStateIndex = 0;
        private double _guessCount;

        public Flib(int stateCount) {
            _states = new State[stateCount];
        }

        public Flib(State[] states) {
            _states = states;
        }

        public void Step(int input, int output) {
            Branch branch = _states[_curStateIndex].Branches[input];
            if (branch.Output == output)
                _guessCount++;
            _curStateIndex = branch.StateIndex;
        }

        public double Fitness {
            get { return _guessCount; }
        }

        public void Nulling() {
            _guessCount = 0;
            _curStateIndex = 0;
        }

        public State[] States {
            get { return _states; }
        }

        public Flib Clone() {
            Flib flib = new Flib(_states.Length);
            flib._curStateIndex = _curStateIndex;
            flib._guessCount = _guessCount;

            for (int i = 0; i < _states.Length; i++) {
                flib.States[i] = _states[i].Clone();
            }

            return flib;
        }
    }

}