using System;
using System.Collections;

namespace Flibs {
    public class FlibRestorer {
        public void Restore(Random random, Flib flib) {
            SortedList indexes = InitIndexesList(flib);
            for (int i = 0; i < flib.States.Length; i++) {
                if (!indexes.Contains(i)) {
                    int index = (int) indexes.GetKey(random.Next(indexes.Count));
                    int branchNum = random.Next(Branch.TARGET_COUNT);
                    flib.States[i].Branches[branchNum] = new Branch(flib.States[index].Branches[branchNum].StateIndex,
                                                                    flib.States[i].Branches[branchNum].Output);
                    flib.States[index].Branches[branchNum] = new Branch(i, flib.States[index].Branches[branchNum].Output);
                    AddIndex(indexes, i, flib);
                }
            }
        }

        private SortedList InitIndexesList(Flib flib) {
            SortedList indexes = new SortedList();
            int index = 0;
            AddIndex(indexes, index, flib);

            return indexes;
        }

        private void AddIndex(SortedList indexes, int index, Flib flib) {
            indexes[index] = 0;
            foreach (Branch branch in  flib.States[index].Branches) {
                if (!indexes.Contains(branch.StateIndex))
                    AddIndex(indexes, branch.StateIndex, flib);
            }
        }
    }
}