using System;

namespace Flibs {
    public class SimpleCrossover : ICrossover {
        public SimpleCrossover() {
        }

        public virtual Flib CreateChild(Random random, Flib firstParent, Flib secondParent) {
            Flib result = new Flib(firstParent.States.Length);

            int bound = random.Next(result.States.Length);

            for(int i = 0; i < result.States.Length; i++) {
                if(i < bound)
                    result.States[i] = firstParent.States[i].Clone();
                else if(i > bound)
                    result.States[i] = secondParent.States[i].Clone();
                else
                    result.States[i] = CreateState(random, firstParent.States[i], firstParent.States[i]);
            }

            return result;
        }

        private State CreateState(Random random, State firstState, State secondState) {
            State result = new State();

            int bound = random.Next(result.Branches.Length);
            for(int i = 0; i < result.Branches.Length; i++) {
                if(i < bound)
                    result.Branches[i] = firstState.Branches[i].Clone();
                else
                    result.Branches[i] = secondState.Branches[i].Clone();
            }

            return result;

        }
    }
}