using System;

namespace Flibs {
    public class SimpleMutation : IMutation {
        private double _mutationProbability;

        public SimpleMutation(double mutationProbability) {
            _mutationProbability = mutationProbability;
        }

        public void Mutate(Random random, Flib flib) {
            if(random.NextDouble() > _mutationProbability) return;

            MutateState(random, flib.States[random.Next(flib.States.Length)], flib.States.Length);
        }

        private void MutateState(Random random, State state, int stateCount) {
            int branchIndex = random.Next(Branch.TARGET_COUNT);
            state.Branches[branchIndex] = MutateBranch(random, state.Branches[branchIndex], stateCount);           
        }

        private Branch MutateBranch(Random random, Branch branch, int stateCount) {
            if(random.NextDouble() < 0.5)
                return new Branch(random.Next(stateCount), branch.Output) ;
            else
                return new Branch(branch.StateIndex, random.Next(Branch.TARGET_COUNT));
        }
    }
}