using System;
using System.Collections;

namespace Flibs {
    public class TournamentGeneartionCreator :IGenerationCreator {
        private int _elitismCount;

        public TournamentGeneartionCreator(int elitismCount) {
            _elitismCount = elitismCount;
        }

        public IList CreateGenearation(Random random, IList generation, IChildCreator childCreator) {
            ArrayList result = new ArrayList(generation.Count);

            result.AddRange(childCreator.GetBestFlibs(generation, _elitismCount));
        
            while(result.Count < generation.Count) {
                result.Add(childCreator.CreateChild(GetParent(generation, random), GetParent(generation, random)));
            }
        
            return result;
        }

        private Flib GetParent(IList generation, Random random) {
            Flib firstPretendent = (Flib) generation[random.Next(generation.Count)];
            Flib secondPretendent = (Flib) generation[random.Next(generation.Count)];
            if(firstPretendent.Fitness > secondPretendent.Fitness)
                return firstPretendent;
            else
                return secondPretendent;
        }
    }
}