using System;

namespace Flibs {
    public class TwoPointCrossover : ICrossover {
        public Flib CreateChild(Random random, Flib firstParent, Flib secondParent) {
            Flib result = firstParent.Clone();

            int bound1 = random.Next(1, result.States.Length - 1);
            int bound2 = random.Next(bound1 + 1, result.States.Length);

            result.States[bound1 - 1] = CreateState(random, firstParent.States[bound1 - 1], secondParent.States[bound1 - 1]);
            result.States[bound2] = CreateState(random, secondParent.States[bound2], firstParent.States[bound2]);

            for (int i = bound1; i < bound2; i++) {
                result.States[i] = secondParent.States[i].Clone();
            }

            result.Nulling();

            return result;
        }

        private State CreateState(Random random, State firstState, State secondState) {
            State result = new State();

            int bound = random.Next(result.Branches.Length);
            for(int i = 0; i < result.Branches.Length; i++) {
                if(i < bound)
                    result.Branches[i] = firstState.Branches[i].Clone();
                else
                    result.Branches[i] = secondState.Branches[i].Clone();
            }

            return result;
        }
    }
}