using System;
using System.Collections;
using System.IO;

namespace WinTestRunner {
    [Serializable]
    public class PlotData {
        private readonly ArrayList _x = new ArrayList();
        private readonly ArrayList _y = new ArrayList();

        public PlotData(ArrayList x, ArrayList y) {
            _x = x;
            _y = y;
        }

        public PlotData(string fileName) {
            using (FileStream stream = File.Open(fileName, FileMode.Open)) {
                TextReader reader = new StreamReader(stream);
                for (string line = reader.ReadLine(); line != null; line = reader.ReadLine()) {
                    string[] items = line.Split('\t');
                    _x.Add(float.Parse(items[0]));
                    _y.Add(float.Parse(items[1]));
                }
            }
        }

        public void Save(string fileName) {
            using (FileStream stream = File.Open(fileName, FileMode.Create)) {
                TextWriter writer = new StreamWriter(stream);

                for (int i = 0; i < _x.Count; i++) {
                    writer.WriteLine(_x[i] + "\t" + _y[i]);
                }

                writer.Close();
            }
        }

        public ArrayList X {
            get { return _x; }
        }

        public ArrayList Y {
            get { return _y; }
        }
    }
}