using System.ComponentModel;
using System.Windows.Forms;
using NPlot;
using PlotSurface2D = NPlot.Windows.PlotSurface2D;

namespace WinTestRunner {
    public class PlotViewer : Form {
        private PlotSurface2D _plotSurface2D;
        private System.Windows.Forms.Button _redAddButton;
        private System.Windows.Forms.Button _greenAddButton;
        private System.Windows.Forms.Button _blueAddButton;
        private Container components = null;

        public PlotViewer() {
            InitializeComponent();

        }

        private void AddPlot(Button button) {
            OpenFileDialog fileDialog = new OpenFileDialog();
            if (fileDialog.ShowDialog() != DialogResult.OK)
                return;

            PlotData plotData = new PlotData(fileDialog.FileName);

            plotData.Save(fileDialog.FileName + "_");
            LinePlot plot = new LinePlot(plotData.Y, plotData.X);
            plot.Color = button.BackColor;
            _plotSurface2D.Add(plot);
            _plotSurface2D.Refresh();
            button.Enabled = false;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing) {
            if (disposing) {
                if (components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            this._plotSurface2D = new NPlot.Windows.PlotSurface2D();
            this._redAddButton = new System.Windows.Forms.Button();
            this._greenAddButton = new System.Windows.Forms.Button();
            this._blueAddButton = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // _plotSurface2D
            // 
            this._plotSurface2D.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this._plotSurface2D.AutoScaleAutoGeneratedAxes = true;
            this._plotSurface2D.AutoScaleTitle = true;
            this._plotSurface2D.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this._plotSurface2D.DateTimeToolTip = false;
            this._plotSurface2D.Legend = null;
            this._plotSurface2D.LegendZOrder = -1;
            this._plotSurface2D.Location = new System.Drawing.Point(8, 8);
            this._plotSurface2D.Name = "_plotSurface2D";
            this._plotSurface2D.Padding = 10;
            this._plotSurface2D.RightMenu = null;
            this._plotSurface2D.ShowCoordinates = true;
            this._plotSurface2D.Size = new System.Drawing.Size(512, 312);
            this._plotSurface2D.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.None;
            this._plotSurface2D.TabIndex = 2;
            this._plotSurface2D.Title = "";
            this._plotSurface2D.TitleFont = new System.Drawing.Font("Arial", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this._plotSurface2D.XAxis1 = null;
            this._plotSurface2D.XAxis2 = null;
            this._plotSurface2D.YAxis1 = null;
            this._plotSurface2D.YAxis2 = null;
            // 
            // _redAddButton
            // 
            this._redAddButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this._redAddButton.BackColor = System.Drawing.Color.Red;
            this._redAddButton.Location = new System.Drawing.Point(136, 328);
            this._redAddButton.Name = "_redAddButton";
            this._redAddButton.Size = new System.Drawing.Size(120, 23);
            this._redAddButton.TabIndex = 3;
            this._redAddButton.Text = " ";
            this._redAddButton.Click += new System.EventHandler(this._addButton_Click);
            // 
            // _greenAddButton
            // 
            this._greenAddButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this._greenAddButton.BackColor = System.Drawing.Color.Green;
            this._greenAddButton.Location = new System.Drawing.Point(264, 328);
            this._greenAddButton.Name = "_greenAddButton";
            this._greenAddButton.Size = new System.Drawing.Size(120, 23);
            this._greenAddButton.TabIndex = 4;
            this._greenAddButton.Text = " ";
            this._greenAddButton.Click += new System.EventHandler(this._addButton_Click);
            // 
            // _blueAddButton
            // 
            this._blueAddButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this._blueAddButton.BackColor = System.Drawing.Color.Blue;
            this._blueAddButton.Location = new System.Drawing.Point(8, 328);
            this._blueAddButton.Name = "_blueAddButton";
            this._blueAddButton.Size = new System.Drawing.Size(120, 23);
            this._blueAddButton.TabIndex = 5;
            this._blueAddButton.Text = " ";
            this._blueAddButton.Click += new System.EventHandler(this._addButton_Click);
            // 
            // PlotViewer
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(528, 358);
            this.Controls.Add(this._blueAddButton);
            this.Controls.Add(this._greenAddButton);
            this.Controls.Add(this._redAddButton);
            this.Controls.Add(this._plotSurface2D);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "PlotViewer";
            this.ShowInTaskbar = false;
            this.Text = "PlotViewer";
            this.ResumeLayout(false);

        }

        #endregion

        private void _addButton_Click(object sender, System.EventArgs e) {
            AddPlot((Button)sender);
        }
    }
}